#include "robot.h"

//Dichiarazione degli oggetti con passaggio dei relativi pin al costruttore
//Motore sinistro e destro
motori motosx(5,6), motodx(10,11);

//PIN
//Fototransistor anteriori
const short ftrans_sx=0, ftrans_c=1, ftrans_dx=2;

//Digitale per il contagiri
//const short encoder=4;

//Valori analogici superficie e linea
byte line[3]={
  255,255,255};
//Variabile per identificare se la linea è nera
boolean contrast;
//Variabile per la lettura dei valori del telecomando
char codice='\0';


void calibra();
void percorso();
//Muove il robot nella direzione passata (2: avanti, 6: destra, 8: indietro, 4: sinistra) e per il numero di raggi passati dalla
//funzione
void muovi(int dir);
boolean acceso(short);

void setup()
{
  //Apre la comunicazione seriale
  //con l'xbee sui pin predefiniti 0 e 1
  Serial.begin(9600);
  //Encoder dichiarato in input
  //pinMode(encoder, INPUT);
}


void loop()
{
  codice='\0';

  if (Serial.available() > 0) {
    codice=(char)Serial.read();
    Serial.flush();

    switch (codice) {
    case 'c':
      calibra();
      break;
    case 'p':
      if (line[0]==255 || line[1]==255 || line[2]==255) {
        Serial.println("Non hai effettuato la calibrazione");
        break;
      }
      else percorso();
      break;
    }
  }
}

void calibra()
{


  line[1]=analogRead(ftrans_c)/100;
  line[0]=analogRead(ftrans_sx)/100;
  line[2]=analogRead(ftrans_dx)/100;
  delay(10);
  muovi(4);
  delay(500);
  contrast=line[2]>analogRead(ftrans_dx)/100;
  delay(10);
  motosx.fermo();
  motodx.muovi(0);
  delay(500);
  muovi(5);
  Serial.print("Sensore sinistro");
  Serial.println(line[0]);
  Serial.print("Sensore centrale");
  Serial.println(line[1]);
  Serial.print("Sensore destro");
  Serial.println(line[2]);
  if (contrast)   Serial.println("Linea scura");
  else   Serial.println("Linea chiara");
}

void percorso()
{
  boolean manovra=0;

  while (1) {
    //IF SERIALREAD()== CODICE SERIALE DI STOP************************************************
    if (Serial.available() > 0 && (char)Serial.read()=='s')
    {
      muovi(5);
      break;
    }
    if (acceso(ftrans_sx) && acceso(ftrans_c) && acceso(ftrans_dx)) muovi(1);
    else if (acceso(ftrans_sx)) { 
      muovi(4); 
      manovra=4;
    }
    else if (acceso(ftrans_dx)) { 
      muovi(2); 
      manovra=2;
    }
    else if  (!acceso(ftrans_sx) && !acceso(ftrans_c) && !acceso(ftrans_dx)) {
      muovi(manovra);
    }
    else muovi(1);
  }
}

void muovi(int dir)
{
  //boolean val_encoder;

  //Lettura dello stato dell'encoder
  //val_encoder=digitalRead(encoder);

  switch (dir) {
  case 1:  //Avanti
    motosx.muovi(1);
    motodx.muovi(1);
    break;
  case 3: //Indietro
    motosx.muovi(0);
    motodx.muovi(0);
    break;
  case 2: //Destra
    motosx.muovi(1);
    //motodx.muovi(0);
    motodx.fermo();
    break;	
  case 4: //Sinistra
    //motosx.muovi(0);
    motosx.fermo();
    motodx.muovi(1);
    break;
    case 5: //Stop
    motosx.fermo();
    motodx.fermo();
    break;
  }

  /*
  //movimento per n_raggi della ruota
   for (int raggio=0; raggio<n_raggi;)
   //Quando l'encoder cambia stato, viene aggiunto un raggio al contatore
   if (digitalRead(encoder)!=val_encoder) {
   val_encoder=!val_encoder;
   raggio++;
   }
   */

  return;
}


boolean acceso(short a)
{
  //int val;
  //val=analogRead(a)/100;
  //SE la linea è scura e la lettura è maggiore o uguale alla linea, il sensore è sulla linea
  //oppure SE la linea è chiara e la misura è minore o uguale alla linea, il sensore è sulla linea
  if ((analogRead(a)/100>=line[a]&&contrast)||(analogRead(a)/100<=line[a]&&!contrast)) return true;
  else return false;		
}



